unit Monstr;

interface
uses Attack, BotUnit;

type

//,   ""

  TMonstr = class
  private
    name   : string;
    Player : TPlayer;
    human  : TGameObject;
  public
    state  : integer;                                         //
    attack : TAttack;                                         //
                                                              // ""
    constructor Create(Parent : TPlayer; hplayer: TGameObject);
    procedure   Run (event : integer);                        //
                                                              //

                                                              //
                                                              //
    procedure   z01 ();
    procedure   z03 ();
    procedure   z04 ();
  end;

implementation

uses BotDemo, SysUtils;

constructor TMonstr.Create;
begin
  attack := TAttack.Create(parent, hplayer);
  state  := 0;
  name   := '""';
  player := parent;
  human  := hplayer;
end;

// 

procedure TMonstr.Run;
var
  newstate : integer;
begin
  newstate := -1;
  Log(' ' + name + '    ' + IntToStr(state) +
      '   e' + IntToStr(event));
  case state of
    0: begin
         case event of
           1:                                             newstate := 1;
           2: begin
                z03();                                    newstate := 1;
              end;
           3:                                             newstate := 2;
           7: begin
                z04();                                    newstate := 0;
              end;
         end;
       end;
    1: begin
         case event of
           2: z03();
           3:                                             newstate := 2;
           4: newstate := 0;
           7: begin
                z04();                                    newstate := 0;
              end;
         end;
       end;
    2: begin
         attack.Run(event);
         case event of
           2: z03();
           5: begin
                                                          newstate := 1;
              end;
           6: begin
                                                          newstate := 0;
              end;
           7: begin
                z04();
                                                          newstate := 0;
              end;
         end;
       end;
    3: begin
       end;
  end;
  if (newstate >= 0) and (state<>newstate) then
  begin
    Log(' ' + name + '    ' + IntToStr(state) +
        '   ' + IntToStr(newstate));
    state := newstate;
    case state of
      0: begin
           z04();
         end;
      1: begin
           z01();
         end;
      2: begin
           attack.Run(0);
         end;
      3: begin
         end;
    end;
  end;
  Log(' ' + name + '    e' + IntToStr(event) +
      '   ' + IntToStr(state));
end;

// 

procedure TMonstr.z01;
begin
//  log('  z01 - ');
  player.search := 64;
end;

procedure TMonstr.z03;
begin
//  log('  z03 -  ');
  Agression := false;
end;

procedure TMonstr.z04;
begin
//  log('  z04 -  ');
  Agression := true;
end;

end.

