unit Attack;

interface

uses BotUnit;

var
  Agression : boolean = true;

type

//,   ""

  TAttack = class
  private
    state : integer;
    name  : string;
    Player : TPlayer;
    human  : TGameObject;
  public
    turnLeft : boolean;

    constructor Create(Parent: TPlayer;  HPlayer: TGameObject);
    procedure   Run (event : integer);                          //
                                                                //

                                                                //
                                                                //

    function    x11() : boolean;
    function    x12() : boolean;

                                                                //
                                                                //

    procedure   z11 ();
    procedure   z12 ();
  end;

implementation

uses BotDemo, SysUtils, Math;

constructor TAttack.Create;
begin
  state  := 0;
  name   := '""';
  player := parent;
  human  := hplayer;
end;

// 

procedure TAttack.Run;
var
  newstate      : integer;
begin
  if event <> 1024 then
    Log(' ' + name + '    ' + IntToStr(state) +
        '   e' + IntToStr(event));
  newstate := -1;
  case state of
    0: begin
         if x11() and x12() and (event=0) then
                                                                newstate := 1;
         if x11() and not x12() and (event=0) then
                                                                newstate := 2;
         if not x11() and (event=0) then
                                                                newstate := 3;
       end;
    1: begin
         if x11() and x12() then
           z11();
         if x11() and not x12() then
                                                                newstate := 2;
         if not x11() then
                                                                newstate := 3;
         if (event=5) or (event=6) or (event=7) then
                                                                newstate := 0;
       end;
    2: begin
         if x11() and not x12() then
         begin
           z11();
           z12();
         end;
         if x11() and x12() then
                                                                newstate := 1;
         if not x11() then
                                                                newstate := 3;
         if (event=5) or (event=6) or (event=7) then
                                                                newstate := 0;
       end;
    3: begin
         if not x11() then
         begin
           z11();
           z12();
         end;
         if (event=5) or (event=6) or (event=7) then
                                                                newstate := 0;
       end;
  end;
  if (newstate >= 0) and (state<>newstate) then
  begin
    if event <> 1024 then
      Log(' ' + name + '    ' + IntToStr(state) +
          '   ' + IntToStr(newstate));
    state := newstate;
    case state of
      0: ;
      1: z11();
      2: begin
           z11();
           z12();
         end;
      3: begin
           z11();
           z12();
         end;
    end;
  end;
  if event <> 1024 then
    Log(' ' + name + '    e' + IntToStr(event) +
        '   ' + IntToStr(state));
end;

// 

procedure TAttack.z11;
var
  angle : double;
begin
//  log('  z11 -    ');
  if player.direction*cor < - Pi then
    angle := player.direction*cor + 2*Pi
  else
    angle := player.direction*cor;
  if arctan2(human.yPosition - player.yPosition, human.xPosition - player.xPosition) < angle then
  begin
    player.DoLeft();
    turnLeft := true;
  end
  else
  begin
    player.DoRight();
    turnLeft := false;
  end;
  player.doStep();
end;

procedure TAttack.z12;
begin
//  log('  z12 - ');
  player.DoFire();
end;

// 

function TAttack.x11;
begin
//  log('    x11 (  )');
  result := Agression;
end;

function TAttack.x12;
begin
//  log('    x12 (   )');
  result := false;
end;

end.

